.\" $OpenBSD: vge.4,v 1.20 2013/03/30 05:34:53 brad Exp $
.\" $FreeBSD: vge.4,v 1.6 2004/11/24 19:06:43 brueffer Exp $
.\"
.\" Copyright (c) 2004
.\"	Bill Paul <wpaul@windriver.com>. All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by Bill Paul.
.\" 4. Neither the name of the author nor the names of any co-contributors
.\"    may be used to endorse or promote products derived from this software
.\"   without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY Bill Paul AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL Bill Paul OR THE VOICES IN HIS HEAD
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
.\" THE POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd $Mdocdate: March 30 2013 $
.Dt VGE 4
.Os
.Sh NAME
.Nm vge
.Nd VIA Velocity 10/100/Gigabit Ethernet device
.Sh SYNOPSIS
.Cd "vge* at pci?"
.Cd "ciphy* at mii?"
.Cd "ipgphy* at mii?"
.Sh DESCRIPTION
The
.Nm
driver provides support for various NICs and embedded Ethernet interfaces
based on the VIA Networking Technologies VT6120, VT6122, VT6130 and VT6132
Gigabit Ethernet controller chips, including the following:
.Pp
.Bl -bullet -compact
.It
ZyXEL GN650-T 64-bit PCI Gigabit Ethernet NIC (ZX1701)
.It
ZyXEL GN670-T 32-bit PCI Gigabit Ethernet NIC (ZX1702)
.El
.Pp
The VT6120/VT6122 is a 33/66MHz 64-bit PCI device which combines a tri-speed
MAC with an integrated 10/100/1000 copper PHY.
(Some older cards use an external PHY.)
The VT6130/VT6132 is the PCI Express version.
The MAC supports IPv4 transmit/receive IP/TCP/UDP checksum offload,
VLAN tag insertion and stripping, a 64-entry CAM filter and a 64-entry
VLAN filter, 64-bit multicast hash filter, 4 separate transmit DMA
queues, flow control and Jumbo frames (not on VT6130/VT6132) up to 16K
in size.
The Velocity family has a 16K receive FIFO and 48K transmit FIFO.
.Pp
The
.Nm
driver takes advantage of the IPv4 transmit/receive IP/TCP/UDP checksum
offload, VLAN tag insertion and stripping, and the CAM filter support.
The CAM filter is used for multicast address filtering to provide
64 perfect multicast address filter support.
If it is necessary for the interface to join more than 64 multicast
groups, the driver will switch over to using the hash filter.
.Pp
The
.Nm
driver supports the following media types:
.Bl -tag -width 10baseTXUTP
.It Cm autoselect
Enable autoselection of the media type and options.
The user can manually override the autoselected mode by adding media
options to the appropriate
.Xr hostname.if 5
file.
.It Cm 10baseT/UTP
Set 10Mbps operation.
The
.Xr ifconfig 8
.Ic mediaopt
option can also be used to select either
.Cm full-duplex
or
.Cm half-duplex
modes.
.It Cm 100baseTX
Set 100Mbps (Fast Ethernet) operation.
The
.Xr ifconfig 8
.Ic mediaopt
option can also be used to select either
.Cm full-duplex
or
.Cm half-duplex
modes.
.It Cm 1000baseT
Set 1000baseT operation over twisted pair.
Both
.Cm full-duplex
and
.Cm half-duplex
modes are supported.
.El
.Pp
The
.Nm
driver supports the following media options:
.Bl -tag -width full-duplex
.It Cm full-duplex
Force full duplex operation.
.It Cm half-duplex
Force half duplex operation.
.El
.Pp
For more information on configuring this device, see
.Xr ifconfig 8 .
.Sh SEE ALSO
.Xr arp 4 ,
.Xr ciphy 4 ,
.Xr ifmedia 4 ,
.Xr intro 4 ,
.Xr ipgphy 4 ,
.Xr netintro 4 ,
.Xr pci 4 ,
.Xr hostname.if 5 ,
.Xr ifconfig 8
.Sh HISTORY
The
.Nm
device driver first appeared in
.Ox 3.7 .
.Sh AUTHORS
.An -nosplit
The
.Nm
driver was written by
.An Bill Paul Aq wpaul@windriver.com
and ported to
.Ox
by
.An Peter Valchev Aq pvalchev@openbsd.org .
